<?php
/*
Plugin Name: Bainternet Simple TOC
Plugin URI: http://en.bainternet.info/2011/simple-toc-table-of-contents-plugin
Description: Automatically create a wiki like TOC (table of contents) in your posts or pages using shortcode based on your headings.
Version: 0.5
Author: Bainternet
Author URI: http://en.bainternet.info
*/
/*  Copyright 2011 Ohad Raz aKa BaInternet  (email : admin@bainternet.info)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


if (!class_exists('simple_toc')) {
	class simple_toc{

		function __construct() {
			add_action( 'admin_init', array( $this, 'action_admin_init' ) );
			add_filter("the_content", array( $this, "bainternet_generate_toc" ));
			add_filter("the_content", array( $this, "bainternet_generate_toc_encoded" ));
			add_filter("the_content", array( $this, "toc_by_h_tags" ));
			
		}
		
		//when using tinymce button you need < > are encoded
		public function bainternet_generate_toc_encoded($content) {
			global $toc_u,$post;
			//$this->toc_by_h_tags($content);
			$pos = strpos($content, "[---TOC---]");
			if ($pos === false  || $toc_u) {
				return $content;
			}
			$pos = strpos($content, "[---TOC Header:");
			if ($pos >= 0) {
				$toc_header = '';
				$start = strpos($content, "[---TOC Header:");
				$end = strpos($content, "---]",$start);
				$h = substr($content,$start,($end + 4 - $start));
				$he = str_replace('[---TOC Header:','',$h);
				$he = str_replace('---]','',$he);
				$toc = '<div class="toc"><div class="toc-head">'.apply_filters('Simple_TOC_Heading',$he,$post).'</div><div class="toc_list">';
				$content = str_replace($h,'',$content);
			}else{
				$toc = '<div class="toc"><div class="toc_list">';
			}
			$toc .= apply_filters('Simple_TOC_before_items','',$post).'<ul>';
			$toc .= apply_filters('Simple_TOC_before_first_item','',$post);
			$count = 0;
			while (strpos($content, "[---TOC Heading:") > 0){
				$start = $end = $heading = $h = $anchor = '';
				$start = strpos($content, "[---TOC Heading:");
				$end = strpos($content, "---]",$start);
				$h = substr($content,$start,($end + 4 - $start));
				$heading = str_replace ("[---TOC Heading:",'',$h);
				$heading = str_replace ("---]",'',$heading);
				$heading_slug = str_replace (" ",'-',$heading);
				//fix none unicode anchors?
				$heading_slug = apply_filters('Simple_TOC_Heading_Slugs',anitize_title($heading_slug),$post);
				$anchor = '<a name="toc-'.$heading_slug.'" style="text-decoration: none;">&nbsp;&nbsp;</a>'; 
				$content = str_replace($h, $anchor,$content);
				$toc .= '<li class="toc_item"><a href="#toc-'.$heading_slug.'">'.$heading.'</a></li>';
				$count = $count + 1;
			}
			$toc .= apply_filters('Simple_TOC_After_Last_item','',$post);
			$toc .= '</ul></div></div>';
			$content = str_replace("[---TOC---]", $toc,$content);
			$toc_u = true;
			return $content;
		}
		//backwords capabilities
		public function bainternet_generate_toc($content) {
			global $toc_u;
			$pos = strpos($content, "<---TOC--->");
			if ($pos === false  || $toc_u) {
				return $content;
			}
			$toc = '<div class="toc"><div class="toc_list"><ul>';
					
			$count = 0;
			while (strpos($content, "<---TOC Heading:") > 0){
				$start = $end = $heading = $h = $anchor = '';
				$start = strpos($content, "<---TOC Heading:");
				$end = strpos($content, "--->",$start);
				$h = substr($content,$start,($end + 4 - $start));
				$heading = str_replace ("<---TOC Heading:",'',$h);
				$heading = str_replace ("--->",'',$heading);
				$heading_slug = str_replace (" ",'-',$heading);
				$anchor = '<a name="toc-'.$heading_slug.'" style="text-decoration: none;">&nbsp;&nbsp;</a>'; 
				$content = str_replace($h, $anchor,$content);
				$toc .= '<li class="toc_item"><a href="#toc-'.$heading_slug.'">'.$heading.'</a></li>';
				$count = $count + 1;
			}
			$toc .= '</ul></div></div>';
			$content = str_replace("<---TOC--->", $toc,$content);
			$toc_u = true;
			return $content;
		}
		
		function action_admin_init() {
			// only hook up these filters if we're in the admin panel, and the current user has permission
			// to edit posts and pages
			if ( current_user_can( 'edit_posts' ) && current_user_can( 'edit_pages' ) ) {
				add_filter( 'mce_buttons', array( $this, 'filter_mce_button' ) );
				add_filter( 'mce_external_plugins', array( $this, 'filter_mce_plugin' ) );
			}
		}
		
		function filter_mce_button( $buttons ) {
			// add a separation before our button, here our button's id is "TOC_button"
			array_push( $buttons, '|', 'TOC_button' );
			return $buttons;
		}
		
		function filter_mce_plugin( $plugins ) {
			// this plugin file will work the magic of our button
			$plugins['TOC'] = plugin_dir_url( __FILE__ ) . 'toc_plugin.js';
			return $plugins;
		}
		
		public function toc_by_h_tags($content){
			$pos = strpos($content, "[---ATOC---]");
			if ($pos === false) {
				return $content;
			}
			$pos = strpos($content, "[---TOC Header:");
			if ($pos != false) {
				$start = strpos($content, "[---TOC Header:");
				$end = strpos($content, "---]",$start);
				$h = substr($content,$start,($end + 4 - $start));
				$he = str_replace('[---TOC Header:','',$h);
				$he = str_replace('---]','',$he);
				$toc = '<div class="toc"><div class="toc-head">'.apply_filters('Simple_TOC_Heading',$he,$post).'</div><div class="toc_list">';
				$content = str_replace($h,'',$content);
			}else{
				$toc = '<div class="toc"><div class="toc_list">';
			}
			$toc .= apply_filters('Simple_TOC_before_items','',$post).'<ul>';
			$toc .= apply_filters('Simple_TOC_before_first_item','',$post);
			//tag is?
			$start = $end = '';
			$start = strpos($content, "[---TAG:");
			$end = strpos($content, "---]",$start);
			$tag_c = substr($content,$start,($end + 4 - $start));
			$tag = str_replace('[---TAG:','',$tag_c);
			$tag = str_replace('---]','',$tag);
			$content = str_replace($tag_c,'',$content);
			
			
			
			$doc = new DOMDocument();
			@$doc->loadHTML($content);
			$headings = $doc->getElementsByTagName($tag);
			foreach ($headings as $heading){
				$h = $heading_slug = $anchor = '';
				$h = $heading->nodeValue;
				$heading_slug = str_replace (" ",'-',$h);
				$heading_slug = apply_filters('Simple_TOC_Heading_Slugs',anitize_title($heading_slug),$post);
				$anchor = '<a name="toc-'.$heading_slug.'" style="text-decoration: none;">&nbsp;&nbsp;</a>'; 
				$toc .= '<li class="toc_item"><a href="#toc-'.$heading_slug.'">'.$h.'</a></li>';
				$content = str_replace($h, $h.$anchor ,$content);
			}
			$toc .= apply_filters('Simple_TOC_After_Last_item','',$post);
			$toc .= '</ul></div></div>';
			
			$content = str_replace("[---ATOC---]", $toc,$content);
			return $content;
		}

	} //end class
} //end if

$simple_toc = new simple_toc();